; #########################################################################
;
;                 To have fun with ASCII additions 
;             Written in MASM32 by Raymond Filiatreault
;                             May 2003
;
; #########################################################################

      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\comctl32.inc

      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\comctl32.lib

; #########################################################################

      return MACRO arg
        mov eax, arg
        ret
      ENDM

    WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
    
; #########################################################################

.data
      hDlg        dd    0
      hInstance   dd    0
      hIcon       dd    0

      length1     dd    0
      length2     dd    0

      converter   db    0

      string1     db    16 dup(0)
      string2     db    16 dup(0)
      results     db    18 dup(0)

; #########################################################################

.code

start:

      invoke GetModuleHandle, NULL
      mov    hInstance, eax
      invoke InitCommonControls
        
      invoke DialogBoxParam,hInstance,700,NULL,ADDR WndProc,NULL

      invoke ExitProcess,eax

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

      .if uMsg == WM_INITDIALOG
            push  hWin
            pop   hDlg
            invoke SendDlgItemMessage,hDlg,704,EM_SETLIMITTEXT,3,0
            invoke SetDlgItemInt,hDlg,704,64,FALSE
            invoke SendDlgItemMessage,hDlg,705,UDM_SETRANGE,0,200070h
            return  TRUE

      .elseif uMsg == WM_COMMAND
            .if   wParam == 721                 ;Exit
                  invoke  EndDialog,hDlg,0
                  
            .elseif wParam == 720               ;OK
                  call  addbytes
                  return  TRUE
            .endif

      .elseif uMsg == WM_CLOSE
            invoke  EndDialog,hDlg,0

      .endif

      return FALSE

WndProc endp

; ########################################################################

addbytes:

      invoke GetDlgItemInt,hDlg,704,0,0
      .if   eax < 20h
            mov   eax,20h
      .elseif eax > 70h
            mov   eax,70h
      .endif
      mov   converter,al
      invoke SetDlgItemInt,hDlg,704,eax,FALSE

      invoke GetDlgItemText,hDlg,701,ADDR string1,16
      mov   length1,eax
      .if   eax == 0
            ret
      .endif

      invoke GetDlgItemText,hDlg,702,ADDR string2,16
      mov   length2,eax
      .if   eax == 0
            ret
      .endif

      push  ebx
      push  esi
      push  edi

      .if   eax > length1           ;string1 needs to be padded
            lea   edi,string1
            add   edi,length1       ;EDI points to terminating 0 of string1
            mov   esi,edi
            sub   eax,length1       ;difference in length
            mov   ecx,eax
            add   edi,ecx
            push  ecx
            mov   ecx,length1
            inc   ecx
            std
            rep   movsb             ;shift the string right
            pop   ecx
            mov   al," "
            rep   stosb             ;pad front end with spaces
            push  length2
            pop   length1           ;update it
            cld
            invoke SetDlgItemText,hDlg,701,ADDR string1
      .elseif eax < length1         ;string2 needs to be padded
            lea   edi,string2
            add   edi,eax           ;EDI points to terminating 0 of string2
            mov   esi,edi
            mov   ecx,length1
            sub   ecx,eax           ;difference in length
            add   edi,ecx
            push  ecx
            mov   ecx,length2
            inc   ecx
            std
            rep   movsb             ;shift the string right
            pop   ecx
            mov   al," "
            rep   stosb             ;pad front end with spaces
            push  length1
            pop   length2           ;update it
            cld
            invoke SetDlgItemText,hDlg,702,ADDR string2
      .endif

      lea   esi,string1
      lea   edi,string2
      mov   ecx,length1
      add   esi,ecx
      add   edi,ecx
      lea   ebx,results+17
      mov   byte ptr [ebx],0
      clc
      pushfd
      
   @@:
      dec   ecx
      js    @F
      dec   edi
      dec   esi
      dec   ebx
      popfd
      mov   al,[esi]
      adc   al,[edi]
      aaa
      pushfd
      add   al,converter
      mov   [ebx],al
      jmp   @B

   @@:
      mov   al," "
      dec   ebx
      popfd
      jnc   @F
      mov   al,converter
      inc   al
   @@:
      mov   [ebx],al

      invoke SetDlgItemText,hDlg,703,ebx

      pop   edi
      pop   esi
      pop   ebx
      ret
      
;--------------------------------------------------------------------------

end start

;##########################################################################

     0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F

20      !  "  #  $  %  &  '  (  )  *  +  ,  -  .  /
30   0  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ?
40   @  A  B  C  D  E  F  G  H  I  J  K  L  M  N  O
50   P  Q  R  S  T  U  V  W  X  Y  Z  [  \  ]  ^  _
60   `  a  b  c  d  e  f  g  h  i  j  k  l  m  n  o
70   p  q  r  s  t  u  v  w  x  y  z  {  |  }  ~  
