; #########################################################################
;
;  WINSQR.ASM is a program to extract the square root of a decimal number
;      with a precision of up to 9999 decimals (written for MASM32).
;
; #########################################################################

;           Assembler specific instructions for 32 bit ASM code

      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################

      include \masm32\include\windows.inc

      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\comctl32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\comdlg32.inc
      
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\comctl32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\comdlg32.lib

; #########################################################################

      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

; #########################################################################

        WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        InputProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

; #########################################################################

    .data
    ALIGN 4
        CommandLine     dd  0
        hWnd            dd  0
        hInstance       dd  0
        hMainMenu       dd  0
        hBox            dd  0
        hEdit           dd  0
        hFile           dd  0
        hFont           dd  0
        hStatus         dd  0
        hHelp           dd  0
        hIcon           dd  0
        lpWorkBuffer    dd  0
        getintbool      dd  0
        lenDecimal      dd  0
        eStyle          dd  0
        helpStyle       dd  0
        time0           dd  0
        rootcode        dd  1
        decinput        dd  0
        answer          dd  0
        buffer          dd  0
        inputadd        dd  0
        inputcnt        dd  0
        firstdec        dd  0
        lastdec         dd  0
        predec          dd  0
        postdec         dd  0
        dispdec         dd  0
        enddisp         dd  0
        written         dd  0

        MainRec         dd  0,0
        MainRecR        dd  0
        MainRecB        dd  0

        sbParts         dd  200,-1

        ofnstruc        dd  76              ;OPENFILENAME struct
        ofnhWnd         dd  0
        ofnhInst        dd  0
        ofnfilt         dd  0
                        dd  0,0,0
        ofnfilad        dd  0
                        dd  400
        ofnname         dd  0
                        dd  40
                        dd  0,0
                        dd  OFN_OVERWRITEPROMPT
                        dw  0,0
                        dd  0,0,0,0

        totlines        db  0
        partline        db  0
        helpcode        db  0

        CtlStyle        db  "RichEdit"
        Nullmsg         db  0
        szRich          db  "RICHED32.DLL",0
        szSavedAs       db  "Saved as "
        savename        db  40 DUP(0)
        saverror        db  "Save Error",0
        szStatus        db  "Status",0
        szComp          db  "Computing...  please wait",0
        szSecs          db  "         seconds",0
        szMaxroot	      db  "Root 512 is the highest permitted",0
        szFilexist	db  "File exists! overwrite?",0
        szrootmsg       db  "Root"
        rootnum         db  "   2  of:  ",0
        szdecreq        db  "Required decimals: "
        decreq          db  "    ",0
        helpTit         db  "** HELP **",0
        szDisplayName   db  "** HIGH PRECISION SQUARE ROOT **",0
        szDecMissing    db  "Decimal input missing!",0
        szNumMissing    db  "Number input missing",0
        szInvalidNum    db  "Only decimal numbers and",10,13
                        db  "one decimal point permitted!",0
        xNumber         db  "Number input:  ",0
        xDecimal        db  "Decimals required:  ",0
        AboutMsg        db  "Originally developed on a TRS-80 (1988)"
                        db  10,13,"Rewritten in Win32 July, 2000"
                        db  10,13,"Copyright  Raymond Filiatreault"
                        db  10,13,"rayfil@hotmail.com",0
        szTitleS        db  "Save file as",0
        szFilterS       db  "All files",0,"*.*",0,0
        dlgname         db  "WINSQR",0

; #########################################################################

    .code

start:
    invoke GetModuleHandle, NULL ; provides the instance handle
    mov hInstance, eax

    invoke GetCommandLine        ; provides the command line address
    mov CommandLine, eax

    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
    
    invoke ExitProcess,eax       ; cleanup & return to operating system

; #########################################################################

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

        ;====================
        ; Put LOCALs on stack
        ;====================

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

        LOCAL Wwd  :DWORD
        LOCAL Wht  :DWORD
        LOCAL Wtx  :DWORD
        LOCAL Wty  :DWORD
        
        szText szClassName,"Sqr_Class"
         
        ;==================================================
        ; Fill WNDCLASSEX structure with required variables
        ;==================================================

        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW or CS_VREDRAW \
                               or CS_BYTEALIGNWINDOW or CS_OWNDC
        mov wc.lpfnWndProc,    offset WndProc      ; address of WndProc
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        m2m wc.hInstance,      hInst               ; instance handle
        mov wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov wc.lpszMenuName,   NULL
        mov wc.lpszClassName,  offset szClassName  ; window class name
            invoke LoadIcon,hInst,200    ; icon ID   ; resource icon
            mov hIcon,eax
        mov wc.hIcon,          eax
            invoke LoadCursor,NULL,IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        0

        invoke RegisterClassEx, ADDR wc     ; register the window class
        invoke LoadLibrary,ADDR szRich

        ; ==================================
        ; Create the main application window
        ; ==================================

        invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR szClassName,
                              ADDR szDisplayName,
                              WS_OVERLAPPEDWINDOW,
                              CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,  
                              NULL,NULL,
                              hInst,NULL

        mov   hWnd,eax

        invoke LoadMenu,hInst,600  ; menu ID
        mov hMainMenu,eax
        invoke SetMenu,hWnd,eax
        invoke EnableMenuItem,hMainMenu,1000,MF_GRAYED
        invoke EnableMenuItem,hMainMenu,1101,MF_GRAYED

        invoke ShowWindow,hWnd,SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow,hWnd                  ; update the display

        invoke LocalAlloc,NULL,32000
        mov lpWorkBuffer,eax
        mov decinput,eax
        mov esi,eax
        add eax,8
        mov inputadd,eax
        add eax,92
        mov answer,eax
        add eax,11000
        mov buffer,eax
        push hWnd
        pop ofnhWnd
        push hInstance
        pop ofnhInst
        mov eax,offset szFilterS
        mov ofnfilt,eax
        mov eax,offset savename
        mov ofnname,eax

        call MainSection

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0         ; get each message
      cmp eax, 0                                  ; exit if GetMessage()
      je ExitLoop                                 ; returns zero
      invoke TranslateMessage, ADDR msg           ; translate it
      invoke DispatchMessage,  ADDR msg           ; send it to message proc
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    .if uMsg == WM_COMMAND
    
    ;======== menu commands ========

        .if wParam == 1001
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
        .endif

        mov eax,wParam
        call chkhelp
        
        .if wParam == 1000
            call saveas
            
        .elseif wParam == 1100     ;new input
            call MainSection

        .elseif wParam == 1101     ;next root

            mov eax,rootcode
            shl eax,1
            mov rootcode,eax
            mov eax,answer
            add eax,predec
            add eax,dispdec
            mov lastdec,eax
            mov eax,postdec
            .if eax == dispdec
                shr eax,1
                mov postdec,eax
            .endif
            call transfr3

        .elseif wParam == 1900
            call Helpme

        .elseif wParam == 1901
            invoke MessageBox,hWin,ADDR AboutMsg,ADDR szDisplayName,
                            MB_ICONINFORMATION

        .endif

    ;====== end menu commands ======

    .elseif uMsg == WM_CREATE

    invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or CCS_TOP,
                    ADDR szStatus,hWin,200
    mov hStatus, eax
      
    invoke SendMessage,hStatus,SB_SETPARTS,2,ADDR sbParts

    mov eStyle, WS_VISIBLE or WS_CHILDWINDOW or \
                WS_VSCROLL or ES_NOHIDESEL or \
                ES_MULTILINE or ES_READONLY

    invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR CtlStyle,NULL,
                          eStyle,0,30,300,200,
                          hWin,700,hInstance,NULL
    mov hEdit, eax

    invoke GetStockObject,SYSTEM_FIXED_FONT
    mov hFont, eax
    invoke SendMessage,hEdit,WM_SETFONT,eax,TRUE
    invoke SendMessage,hEdit,EM_SETBKGNDCOLOR,0,0FFFFFFh

    .elseif uMsg == WM_SIZE

        call    Editsize

    .elseif uMsg == WM_CLOSE
    
        invoke LocalFree,lpWorkBuffer

    .elseif uMsg == WM_DESTROY

        invoke PostQuitMessage,NULL
        return 0 
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; #########################################################################

InputProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    .if uMsg == WM_COMMAND

        .if wParam == 150               ;OK button

            invoke GetDlgItemText,hBox,101,lpWorkBuffer,5
                .if eax == 0
                invoke MessageBox,hBox,ADDR szDecMissing,NULL,\
                MB_OK or MB_ICONSTOP or MB_APPLMODAL
                return TRUE
                .endif

                mov    lenDecimal,eax
                invoke GetDlgItemInt,hBox,101,getintbool,FALSE
                mov    postdec,eax

                invoke GetDlgItemText,hBox,100,inputadd,36
                .if eax == 0
                    invoke MessageBox,hBox,ADDR szNumMissing,NULL,\
                    MB_OK or MB_ICONSTOP or MB_APPLMODAL
                    return TRUE
                .endif

                mov inputcnt,eax
                mov ecx,eax
                mov esi,inputadd
                xor ebx,ebx
             check1:
                lodsb
                cmp al,"."
                jnz check2
                or  ebx,ebx
                jnz check3
                mov ebx,esi
                jmp check5
             check2:
                cmp al,"0"
                jae check4
             check3:
                invoke MessageBox,hBox,ADDR szInvalidNum,NULL,\
                MB_OK or MB_ICONSTOP or MB_APPLMODAL
                return TRUE
             check4:
                cmp al,"9"
                ja  check3
             check5:
                loop check1
	          mov  firstdec,ebx       ;store address of first decimal
                                        ; 0 = no decimal point
            or  ebx,ebx
            jz  check6

            .if inputcnt == 1
                jmp check3              ;invalid if only a decimal
            .endif

            check6:
                invoke EndDialog,hBox,TRUE 
   
        .elseif wParam == 151           ;CANCEL button

                invoke EndDialog,hBox,FALSE 
        .endif
        return FALSE 

    .elseif uMsg == WM_CLOSE
                invoke EndDialog,hBox,FALSE 

    .elseif uMsg == WM_DESTROY
                invoke EndDialog,hBox,FALSE 

    .elseif uMsg == WM_INITDIALOG
        mov eax,hWin
        mov hBox,eax
        invoke SendDlgItemMessage,hBox,100,EM_SETLIMITTEXT,35,NULL
        invoke SendDlgItemMessage,hBox,101,EM_SETLIMITTEXT,4,NULL
        return TRUE

    .endif
    return FALSE

InputProc endp

; ########################################################################

Editsize:
        invoke GetClientRect,hStatus,ADDR MainRec
        push MainRecB

        invoke GetClientRect,hWnd,ADDR MainRec
        mov ebx,MainRecR
        mov eax,MainRecB

        pop edx
        sub eax,edx
        invoke MoveWindow,hEdit,0,edx,ebx,eax,TRUE
        ret

; ########################################################################


MainSection:

    invoke DialogBoxParam,hInstance,ADDR dlgname,hWnd,
                                ADDR InputProc,NULL
     .if eax == FALSE
        ret
     .endif

    mov rootcode,1

;get number of digits before the decimal point

		mov	ebx,firstdec	;get address of first decimal
						;0 = no decimal point
		mov	ecx,inputcnt	;total number of characters
		or	ebx,ebx		;is there a decimal point
		jz	rootof08		;jump if none
		dec	ebx			;gives address of decimal point
		mov	ecx,inputadd	;start address of input
		sub	ebx,ecx		;number of characters before decimal point
		mov	ecx,ebx
rootof08:	mov	predec,ecx		;store it

;convert input number into unpacked decimals in answer area

		mov	esi,inputadd	;effective starting address of input
		mov	ecx,inputcnt	;effective number of characters in input
		mov	edi,answer		;temp. use for unpacked decimals of input
		xor	eax,eax
		cmp	predec,eax		;any digit before decimal point?
		jnz	transfr0		;jump if there are
		stosb				;at least a 0 before decimal point
		inc	predec		;adjust count
		lodsb				;get rid of decimal point
		jmp	short transfr2	;to reduce count in cx

;characters before decimal point

transfr0:   lodsb 			;get ascii character from input
		cmp	al,"."
		jz	transfr2		;jump when "." found
		and	al,0Fh		;convert from ascii to unpacked decimal
		stosb				;store it
		loop	transfr0
            mov lastdec,edi		;save address past last digit
		jmp	short transfr3	;jump if no more characters

;characters after decimal point

transfr1:   lodsb 			;get ascii character
		and	al,0fh		;convert from ascii to unpacked decimal
		stosb				;store it
transfr2:	loop	transfr1		;continue for all decimals
            mov lastdec,edi		;save address past last digit
		
transfr3:	

    invoke SendMessage,hStatus,SB_SETTEXT,0,ADDR szComp
    invoke SendMessage,hStatus,SB_SETTEXT,1,ADDR Nullmsg

    invoke GetTickCount
    mov time0,eax

;******************* calculate square root ********************

;initialize buffer area

            mov	edi,buffer
		mov	ecx,predec
		add	ecx,postdec		;number of working digits
		add	ecx,8             ;for extra digits
		xor	ax,ax
	rep	stosw                   ;need 2 bytes per required digit

		mov	esi,lastdec		;address past last digit
		mov	ecx,esi
		sub	ecx,answer		;less start address of digits
						;ecx = total number of digits
		dec	esi			;address of last digit
		mov	edi,buffer
		add	edi,ecx
		inc	edi

root010:	mov	eax,predec		;# digits in integer portion
		shr	eax,1			;divide by 2
		jnc	root020 		;jump if it was an even number
		inc	eax			;readjust for integer digits in answer
		inc	edi			;for proper lineup
root020:	mov	predec,eax		;now contains count for answer

;multiply input in answer by 5 into buffer (unpacked decimals)

		mov	bx,5
		std				;to get digits from end to front
root030:	lodsb				;get input digit starting from end
            mul	bl
		aam				;multiplication adjust to unpacked decimal
		add	al,bh			;add previous carryover
		mov	bh,ah			;transfer present carryover
		stosb				;store result in work buffer
		loop	root030
		mov	al,bh
		stosb				;store last carryover
		cld				;reset direction flag

		mov	edi,answer
		mov	ecx,buffer
		sub	ecx,edi		;get # bytes in answer buffer
		xor	eax,eax
		shr	ecx,1
	rep	stosw				;initialize answer area

		mov	ecx,predec
		add	ecx,postdec		;total count of digits for answer
		inc	ecx			;additional digit for rounding
		xor	ebx,ebx		;initialize base pointer
		push	postdec
		pop	dispdec

;check if an exact square root has been calculated
;the buffer would then contain all zeros

root040:	cmp	ebx,20		;bx = number of digits already calculated
		jae	root044		;skip checking for exact sqr if =>20
		push	ecx
		mov	ecx,predec
		add	ecx,postdec
		shl	ecx,1
		sub	ecx,ebx		;total number of bytes to check
		shr	ecx,1			;now number of words
		mov	edi,buffer
		add	edi,ebx		;start checking there
		xor	ax,ax
		cld
	repe	scasw				;check for non-zeros
		pop	ecx
		jnz	root044		;jump if non-zero found
		mov	eax,ebx		;number of digits calculated
		sub	eax,predec		;less number of integer digits needed
		jnc	root041		;jump if all integer digits calculated
		neg	eax			;number of additional integer digits needed
						;which will be zeros
		mov	ecx,eax
		xor	eax,eax
		mov	edi,answer
		add	edi,ebx
	rep	stosb				;completes the answer
root041:	mov	dispdec,eax		;number of decimals to be displayed
		jmp	rootx			;skip other sqr calculations

;prepare for calculating the next digit

root044:	mov	esi,answer
		mov	ax,5
		mov	[esi+ebx],ah	;zero current last digit
		inc	ebx
		mov	[esi+ebx],al	;insert as next digit

;check if number in answer can be subtracted from number in work ;buffer

root045:	mov	edi,buffer
		add	edi,ebx
		cmp	byte ptr [edi],0
		jnz	root090
		inc	edi
		push	ecx			;save count
		mov	ecx,ebx		;use current # of digits
		inc	ecx			;to include terminating "5"
		cld
	repe	cmpsb				;compare answer with buffer
		pop	ecx
		jbe	root090 		;jump if answer is =< buffer
		dec	ecx
		jnz	root040 		;to compute next digit if answer > buffer
		jmp	rootx			;exit when all digits computed

;subtract answer from buffer

root090:	mov	edi,buffer
		mov	esi,answer
		add	edi,ebx
		add	edi,ebx
		inc	edi			;last effective digit in work buffer
		add	esi,ebx		; id in answer
		push	ecx
		mov	ecx,ebx		;use current # digits
		inc	ecx			;adjust for terminating "5"
		std

;******     THIS LOOP IS DONE SOME 50,000,000 TIMES FOR 9999 DECIMALS   ****

root100:	mov	al,[edi]		;digit from work buffer
		mov	ah,1			;to take care of any carry
		sub	al,[esi]		;subtract digit from answer
		aas				;adjust for unpacked decimal

		stosb         		;  ***  store result in work buffer  ***

            jnc	root130 		;jump if no borrow
		push	edi			;save address in work buffer
root110:	mov	al,[edi]		;get previous digit in buffer
		or	al,al
		jnz	root120	 	;jump if not a "0"
		mov	byte ptr [edi],9
		dec	edi			;replace the 0 by a 9
		jmp	root110 		;continue checking digits
root120:	dec	byte ptr [edi]	;adjust digit for borrow
		pop	edi
root130:	dec	esi			;adjust address in answer
		dec	ecx
		jnz	root100	 	;continue subtraction of all digits

;******     END OF LOOP     ******

		pop	ecx			;retrieve remaining count
						;si should be at byte preceeding answer
		inc	byte ptr [esi+ebx] ;bump effective digit
		inc	esi
		jmp	root045	 	;continue operation

;computation completed, last required decimal must be rounded if ;necessary

rootx:	std
		mov	edi,answer
		add	edi,ebx		;last digit in answer "5"
		xor	eax,eax
		stosb				;blank it
            mov   lastdec,edi
		mov	eax,postdec		;decimals requested
		cmp	eax,dispdec		;decimals to be displayed
		jnz	times0		;skip rounding if exact square root found
		push	edi
		pop	esi			;address of last computed digit
		push	esi			;save address
		dec	edi			;last required digit
		dec	ebx
		lodsb				;get last computed digit
		cmp	al,5
		cmc				;complement carry flag for later
		jnc	rootx20 		;jump if last digit <5
		mov	ecx,ebx
rootx10:	lodsb				;get previous digit
		inc	al			;round to next number
		aaa				;correction for unpacked decimal
		stosb				;store rounded digit in answer
		jnc	rootx20 		;jump if no carryover
		loop	rootx10 		;continue if carryover
rootx20:	pop	edi			;retrieve address of last computed digit
		pushf				;save flags
		xor	eax,eax
		stosb				;blank digit computed for rounding
		popf
		jnc	times0		;jump if not all "9"s
		inc	predec		;adjust count of integers in answer
		push	edi
		pop	esi			;copy address of last digit
		inc	edi
		mov	ecx,ebx		;count for number of digits in answer
	rep	movsb				;move all digits by one space
		mov	al,1
		stosb				;insert a "1" at the beginning
            inc lastdec

;read clock, compute elapsed time and display it on last line

times0:     invoke GetTickCount
            sub eax,time0
            mov ecx,eax
            mov edi,offset szSecs
            xor dx,dx
            mov bx,1000
            div bx
            push dx
            call convint
            mov al,"."
            stosb
            pop ax
            mov bl,10
            div bl
            push ax
            cbw
            div bl
            add ax,3030h
            stosw
            pop ax
            mov al,ah
            add al,30h
            stosb
            
;prepare for display of results

    mov edi,offset decreq
    mov eax,postdec
    call convint
    mov edi,offset rootnum
    mov eax,rootcode
    shl eax,1
    call convint

    mov edi,buffer
    mov esi,offset szrootmsg
    call copystr
    mov esi,inputadd
    call copystr
    mov ax,0A0Dh
    stosw
    mov esi,offset szdecreq
    call copystr
    mov ax,0A0Dh
    stosw
    stosw

display:	mov	eax,dispdec
		or	eax,eax
		jnz	displaya
		inc	al
		mov	totlines,al
		jmp	short display0
displaya:	mov   bl,50
            div   bl
		or	ah,ah
		jz	displayb
		inc	al
displayb:	mov	totlines,al
		jnz	display0
		mov	ah,50
display0:	mov	partline,ah

displayl:	mov	esi,answer
		mov	ecx,predec
            call	partdis
		dec	edi
		mov	al,"."
		stosb

            xor ecx,ecx
            mov cl,totlines
display2:   cmp cl,1
            jz  display4
            push  ecx
            mov cl,10
display3:   push  ecx
            mov cl,5
            call	partdis
		pop	ecx
		loop	display3
            dec edi
            mov ax,0A0Dh
            stosw
            mov ecx,predec
            inc ecx
            mov al,20h
            rep stosb
            pop ecx
            dec ecx
            jmp display2

display4:   xor eax,eax
            mov al,partline
            mov bl,5
            div bl
            or  al,al
            jz  display6
            mov cl,al
display5:   push ecx
            mov cl,5
            call	partdis
		pop	ecx
		loop	display5
display6:   or  ah,ah
            jz  display7
            mov cl,ah
            call	partdis
display7:   xor ax,ax
            stosb
            mov enddisp,edi

    invoke SendMessage,hStatus,SB_SETTEXT,0,ADDR szSecs
    invoke SetWindowText,hEdit,buffer
    .if rootcode == 256
        invoke EnableMenuItem,hMainMenu,1101,MF_GRAYED
    .else
        invoke EnableMenuItem,hMainMenu,1101,MF_ENABLED
    .endif
    invoke EnableMenuItem,hMainMenu,1000,MF_ENABLED
    invoke HideCaret,hEdit
    or  helpcode,2

    ret

;****************************

partdis:	lodsb
		add	al,30h
		stosb
		loop	partdis
		mov	al," "
		stosb
		ret

;****************************

copystr:
    lodsb
    or  al,al
    jz  copystr1
    stosb
    jmp copystr

copystr1:
    ret

;****************************
    
convint:
    push bx
    push cx
    push dx
    cld
    mov cx,ax
    mov bx,100
    xor dx,dx
    div bx
    or  ax,ax
    jnz convint1
    mov ax,2020h
    jz  convint2
convint1:
    mov bl,10
    div bl
    add ax,3030h
    cmp al,30h
    jnz convint2
    mov al,20h
convint2:
    stosw
    mov ax,dx
    mov bl,10
    div bl
    add ax,3030h
    cmp al,30h
    jnz convint3
    cmp cx,99
    ja  convint3
    mov al,20h
convint3:
    stosw
    pop dx
    pop cx
    pop bx
    ret        

;****************************

saveas:

    mov edi, enddisp    ; address of buffer
    mov ecx, 200        ; buffer length/2
    xor ax,ax
    rep stosw           ; initialize buffer with 0's
    push enddisp
    pop ofnfilad
    
    invoke GetSaveFileName,ADDR ofnstruc

    mov esi,enddisp
    lodsb
    or  al,al
    jnz saveas1
    ret                 ;<< zero if CANCEL pressed in dlgbox

saveas1:
    invoke CreateFile,enddisp,    ; pointer to name of the file
            GENERIC_WRITE,              ; access (read-write) mode
            NULL,                       ; share mode
            NULL,                       ; pointer to security attributes
            CREATE_ALWAYS,              ; how to create
            FILE_ATTRIBUTE_NORMAL,      ; file attributes
            NULL
    mov hFile,eax

    mov eax,enddisp
    sub eax,buffer
    dec eax
    push eax

    invoke WriteFile,hFile,buffer,eax,ADDR written,NULL
    invoke CloseHandle,hFile

    pop eax
    .if eax == written
        invoke SendMessage,hStatus,SB_SETTEXT,1,ADDR szSavedAs
    .else
        invoke MessageBox,hWnd,ADDR saverror,NULL,\
                MB_OK or MB_ICONWARNING or MB_APPLMODAL
    .endif

    ret    

;****************************

    chkhelp:
        .if eax == 1900
            ret
        .endif

        test helpcode,1
        jnz chkhelp1
        ret
    chkhelp1:
        xor helpcode,1
        invoke SendMessage,hEdit,EM_SETBKGNDCOLOR,0,0FFFFFFh
        mov eax,offset Nullmsg
        test helpcode,2
        jz  chkhelp2
        mov eax,buffer
    chkhelp2:
        invoke SetWindowText,hEdit,eax
        ret
        
;****************************

    helptxt db  "** HIGH PRECISION SQUARE ROOT **",13,10,13,10
            db  "** FILE Menu **",13,10,13,10
            db  "Save As:",13,10,13,10
            db  "The result appearing on the screen can be saved as an"
            db  " ASCII text file. You can later load it in any word "
            db  "processor to print it.",13,10,13,10
            db  "You are prompted to provide a file name. There is no "
            db  "default extension. If an existing file is selected, you "
            db  "will be prompted to overwrite it.",13,10,13,10
            db  "Exit:",13,10,13,10
            db  "Take a guess!",13,10,13,10,13,10
            db  "** OPTIONS Menu **",13,10,13,10
            db  "New Input:",13,10,13,10
            db  "A dialog box will pop up to request:",13,10,13,10
            db  "a) input for a number to extract the square root of, "
            db  "the total number of digits allowed (including the "
            db  "decimal point) being limited to 35;",13,10,13,10
            db  "b) input for the required precision, i.e. the number "
            db  "of digits after the decimal point in the answer, 9999 "
            db  "being the upper limit.",13,10,13,10
            db  "An extra decimal is always calculated in order to round "
            db  "the last required one. All other decimals are exact as "
            db  "long as the input number was an exact number. Extracting "
            db  "the square root of 3.1416 would NOT give a precise square "
            db  "root of PI past the 3rd decimal.",13,10,13,10
            db  "Additional 0's are not displayed if an exact root of the "
            db  "number is found.",13,10,13,10
            db  "The time required to perform the calculations is displayed "
            db  "in the status window.",13,10,13,10
            db  "Next Root:",13,10,13,10
            db  "This will calculate the square root of the answer "
            db  "appearing on the screen. The limit is the 512th root of "
            db  "the original number.",13,10,13,10
            db  "Unless the current root is an exact root, the number of "
            db  "decimals in the next root will be halved; additional "
            db  "decimals would not be significant.",13,10,13,10,13,10
            db  "** HELP Menu **",13,10,13,10
            db  "Help:",13,10,13,10
            db  "You are reading it.",13,10,13,10
            db  "About:",13,10,13,10
            db  "General info about program and author.",0

Helpme:

    test helpcode,1
    jz  helpme1
    ret
helpme1:
    invoke SendMessage,hEdit,EM_SETBKGNDCOLOR,0,0FFFF40h
    invoke SetWindowText,hEdit,ADDR helptxt
    or  helpcode,1
    ret

; ########################################################################

end start

